// Mouse.h


#ifndef __GENOME_MIXER_MOUSE__
#define __GENOME_MIXER_MOUSE__

#include "Chromosome.h"
#include <stdlib.h>

#include <iostream>
#include <vector>

#define kMALE   false
#define kFEMALE true

#define kUNDEFINED (-1)

class Mouse {
    private:
	static long static_ID_Counter;
        std::vector<Chromosome*> myPatChr;
	std::vector<Chromosome*> myMatChr;
        string  myName;
        bool	mySex;
        long	myID;
        Mouse	*myMotherPtr;
        Mouse	*myFatherPtr;
        long	myGeneration;
        
    public:
        Mouse::Mouse(string name, long generation, long ID, Mouse *motherPtr, Mouse *fatherPtr, char sex); // Constructor
        
        string Mouse::name() {		return myName;	} // ACCESSOR for private variable
        bool   Mouse::sex() {		return mySex;	} // ACCESSOR for private variable
        long   Mouse::ID() {		return myID;	} // ACCESSOR for private variable
        long   Mouse::generation() {	return myGeneration;	} // ACCESSOR for private variable
        Mouse* Mouse::motherPtr() {	return myMotherPtr;	} // ACCESSOR for private variable
        Mouse* Mouse::fatherPtr() {	return myFatherPtr;	} // ACCESSOR for private variable
	bool   Mouse::isMale() {	return (mySex == kMALE);	}
        bool   Mouse::isFemale() {	return (mySex == kFEMALE);	}
	
        int         Mouse::numChr();
	int         Mouse::geneAtBase(bool side, int chrNum, long locInBases);
        Chromosome* Mouse::getChr(bool side, int chrNum);
	void	    Mouse::setChr(bool side, int chrNum, Chromosome* cPtr);
	void        Mouse::setName(string newName);
	void        Mouse::printSummary(void);
        void        Mouse::printMouseData(void);
	
	// STATIC (CLASS METHODS) BELOW
	static Mouse* Mouse::returnNewPurebredPtr(int setTo, string name, bool sex); // STATIC
	static bool   Mouse::isMale(bool sex)   { return (sex == kMALE); } // STATIC
	static bool   Mouse::isFemale(bool sex) { return (sex == kFEMALE); } // STATIC
	static void   Mouse::resetID_Counter(void);
};  // <-- remember the semicolon at the end of the class definition!

#endif
