#ifndef __GENOME_MIXER_MOUSE_IO__
#define __GENOME_MIXER_MOUSE_IO__

#include "GenomeMixer.h"
#include "MarkerCollection.h"
#include "Mouse.h"
#include "CellData.h"

#include <stdlib.h>
#include <vector>
#include <string>
//#include <exception>

// Note that everything in MouseIO is static; there shouldn't be any instances of this class.
// It's not really a class so much as just a way of keeping related functions together.

using namespace std;

class MouseIO {
 private:
    
 public:
  static int  MouseIO::numFromChar(char c);
  static void MouseIO::writeBreedingSchemeFile(string fileToWrite);
  static MarkerCollection* MouseIO::getMarkerDataFromFile(string markerFileLocation);
  
  static bool MouseIO::decodeCell(MouseCellIngredients *ingredients, string sourceStr, GenomeMixer *mixer);
  static void MouseIO::readBreedingSchemeFile(string fileToRead, GenomeMixer *mixer);
  
  static CellData* MouseIO::stringToCellData(string cell, GenomeMixer *mixer);
  static void      MouseIO::parentStrDecode(string stringItem, GenomeMixer *mixer, int *cagePtr, int *genPtr, int *purebredPtr);
  
  static Mouse* MouseIO::decodeOneSide(string stringItem, bool whichSex, GenomeMixer *mixer);
  static string MouseIO::generationNumToLetters(int number);
  static int   MouseIO::generationFromCellLetters(char letOne, char letTwo);
  
  static char MouseIO::nucleotideToABH(GenomeMixer *mixPtr, int theNum); // <-- calls the function below with arguments (theNum, theNum)
  static char MouseIO::nucleotideToABH(GenomeMixer *mixPtr, int matNum, int patNum);
  static void MouseIO::writeQGeneFiles(string fileToWriteStr, GenomeMixer *mixPtr, string endLineStr);
  static void MouseIO::writeMapManagerFormat(string fileToWriteStr, GenomeMixer *mixPtr, string endLineStr);
  static void MouseIO::writeRQtlFormat(string fileToWriteStr, GenomeMixer *mixPtr, string endLineStr);
  
  static void MouseIO::writeMarkerFile(string fileToWriteStr, GenomeMixer *mixPtr, string endLineStr);
  static void MouseIO::writeSettingsFile(string fileToWriteStr, GenomeMixer *mixPtr, string endLineStr);
};

#endif

